"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@terascope/utils");
const logic_builder_1 = __importDefault(require("./logic-builder"));
const parser_1 = require("../parser");
const _logger = utils_1.debugLogger('document-matcher');
class DocumentMatcher {
    constructor(query, options = {}) {
        const logger = options.logger != null
            ? options.logger.child({ module: 'document-matcher' })
            : _logger;
        const parser = new parser_1.Parser(query, {
            type_config: options.type_config,
            logger,
        });
        this.filterFn = logic_builder_1.default(parser, options.type_config);
    }
    match(doc) {
        return this.filterFn(doc);
    }
}
exports.default = DocumentMatcher;
//# sourceMappingURL=index.js.map