"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const boolean_point_in_polygon_1 = __importDefault(require("@turf/boolean-point-in-polygon"));
// @ts-ignore
const circle_1 = __importDefault(require("@turf/circle"));
const bbox_1 = __importDefault(require("@turf/bbox"));
const bbox_polygon_1 = __importDefault(require("@turf/bbox-polygon"));
const helpers_1 = require("@turf/helpers");
const utils_1 = require("../../utils");
// TODO: we can delete this file when we remove old geo grammer syntax
const testGeoPolygon = (polygon) => (fieldData) => {
    const point = utils_1.parseGeoPoint(fieldData, false);
    if (!point)
        return false;
    return boolean_point_in_polygon_1.default([point.lon, point.lat], polygon);
};
function geoDistance(node) {
    const { distance, unit, lat, lon } = node;
    const geoPoint = [lon, lat];
    const config = { units: unit };
    let polygon;
    if (lat != null && lon != null) {
        polygon = circle_1.default(geoPoint, distance, config);
    }
    // Nothing matches so return false
    if (polygon == null)
        return () => false;
    return testGeoPolygon(polygon);
}
exports.geoDistance = geoDistance;
function geoBoundingBox(node) {
    const topLeft = [node.top_left.lon, node.top_left.lat];
    const bottomRight = [node.bottom_right.lon, node.bottom_right.lat];
    const line = helpers_1.lineString([
        topLeft,
        bottomRight,
    ]);
    const box = bbox_1.default(line);
    const polygon = bbox_polygon_1.default(box);
    // Nothing matches so return false
    if (polygon == null)
        return () => false;
    return testGeoPolygon(polygon);
}
exports.geoBoundingBox = geoBoundingBox;
//# sourceMappingURL=geo.js.map