import { AnyObject } from '@terascope/utils';
declare type GeoPointArr = [number, number];
declare type GeoPointStr = string;
declare type GeoObjShort = {
    lat: string | number;
    lon: string | number;
};
declare type GeoObjLong = {
    latitude: string | number;
    longitude: string | number;
};
export declare type GeoPointInput = GeoPointArr | GeoPointStr | GeoObjShort | GeoObjLong | GeoShapePoint;
export interface GeoDistanceObj {
    distance: number;
    unit: GeoDistanceUnit;
}
export interface GeoPoint {
    lat: number;
    lon: number;
}
export declare enum GeoShapeRelation {
    Intersects = "intersects",
    Disjoint = "disjoint",
    Within = "within",
    Contains = "contains"
}
export declare enum GeoShapeType {
    Point = "Point",
    Polygon = "Polygon",
    MultiPolygon = "MultiPolygon"
}
export declare type GeoShapePoint = {
    type: GeoShapeType.Point;
    coordinates: CoordinateTuple;
};
export declare type GeoShapePolygon = {
    type: GeoShapeType.Polygon;
    coordinates: CoordinateTuple[][];
};
export declare type GeoShapeMultiPolygon = {
    type: GeoShapeType.MultiPolygon;
    coordinates: CoordinateTuple[][][];
};
export declare type GeoShape = GeoShapePoint | GeoShapePolygon | GeoShapeMultiPolygon;
export declare type CoordinateTuple = [number, number];
export declare type GeoDistanceUnit = 'miles' | 'yards' | 'feet' | 'inch' | 'kilometers' | 'meters' | 'centimeters' | 'millimeters' | 'nauticalmiles';
export declare enum FieldType {
    Geo = "geo",
    Date = "date",
    IP = "ip",
    String = "string",
    Integer = "integer",
    Float = "float",
    Boolean = "boolean",
    Object = "object",
    GeoPoint = "geo-point",
    GeoJSON = "geo-json"
}
export interface TypeConfig {
    [field: string]: FieldType;
}
export declare type JoinBy = 'AND' | 'OR';
export interface Variables {
    [key: string]: any;
}
export interface JoinQueryResult {
    query: string;
    variables: Variables;
}
export declare type CreateJoinQueryOptions = {
    typeConfig?: TypeConfig;
    fieldParams?: Record<string, string>;
    joinBy?: JoinBy;
    variables?: AnyObject;
};
export {};
//# sourceMappingURL=interfaces.d.ts.map