"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const parser_1 = require("./parser");
const _cache = new WeakMap();
class CachedParser {
    constructor() {
        _cache.set(this, {});
    }
    make(query, options) {
        return new parser_1.Parser(query, options);
    }
    reset() {
        _cache.delete(this);
        _cache.set(this, {});
    }
}
exports.CachedParser = CachedParser;
//# sourceMappingURL=cached-parser.js.map