// Generated by PEG.js v. 0.10.0 (ts-pegjs plugin v. 0.2.6 )
//
// https://pegjs.org/   https://github.com/metadevpro/ts-pegjs
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const context_1 = __importDefault(require("./context"));
const i = __importStar(require("./interfaces"));
const interfaces_1 = require("../interfaces");
class SyntaxError extends Error {
    constructor(message, expected, found, location) {
        super();
        this.message = message;
        this.expected = expected;
        this.found = found;
        this.location = location;
        this.name = "SyntaxError";
        if (typeof Error.captureStackTrace === "function") {
            Error.captureStackTrace(this, SyntaxError);
        }
    }
    static buildMessage(expected, found) {
        function hex(ch) {
            return ch.charCodeAt(0).toString(16).toUpperCase();
        }
        function literalEscape(s) {
            return s
                .replace(/\\/g, "\\\\")
                .replace(/"/g, "\\\"")
                .replace(/\0/g, "\\0")
                .replace(/\t/g, "\\t")
                .replace(/\n/g, "\\n")
                .replace(/\r/g, "\\r")
                .replace(/[\x00-\x0F]/g, (ch) => "\\x0" + hex(ch))
                .replace(/[\x10-\x1F\x7F-\x9F]/g, (ch) => "\\x" + hex(ch));
        }
        function classEscape(s) {
            return s
                .replace(/\\/g, "\\\\")
                .replace(/\]/g, "\\]")
                .replace(/\^/g, "\\^")
                .replace(/-/g, "\\-")
                .replace(/\0/g, "\\0")
                .replace(/\t/g, "\\t")
                .replace(/\n/g, "\\n")
                .replace(/\r/g, "\\r")
                .replace(/[\x00-\x0F]/g, (ch) => "\\x0" + hex(ch))
                .replace(/[\x10-\x1F\x7F-\x9F]/g, (ch) => "\\x" + hex(ch));
        }
        function describeExpectation(expectation) {
            switch (expectation.type) {
                case "literal":
                    return "\"" + literalEscape(expectation.text) + "\"";
                case "class":
                    const escapedParts = expectation.parts.map((part) => {
                        return Array.isArray(part)
                            ? classEscape(part[0]) + "-" + classEscape(part[1])
                            : classEscape(part);
                    });
                    return "[" + (expectation.inverted ? "^" : "") + escapedParts + "]";
                case "any":
                    return "any character";
                case "end":
                    return "end of input";
                case "other":
                    return expectation.description;
            }
        }
        function describeExpected(expected1) {
            const descriptions = expected1.map(describeExpectation);
            let i;
            let j;
            descriptions.sort();
            if (descriptions.length > 0) {
                for (i = 1, j = 1; i < descriptions.length; i++) {
                    if (descriptions[i - 1] !== descriptions[i]) {
                        descriptions[j] = descriptions[i];
                        j++;
                    }
                }
                descriptions.length = j;
            }
            switch (descriptions.length) {
                case 1:
                    return descriptions[0];
                case 2:
                    return descriptions[0] + " or " + descriptions[1];
                default:
                    return descriptions.slice(0, -1).join(", ")
                        + ", or "
                        + descriptions[descriptions.length - 1];
            }
        }
        function describeFound(found1) {
            return found1 ? "\"" + literalEscape(found1) + "\"" : "end of input";
        }
        return "Expected " + describeExpected(expected) + " but " + describeFound(found) + " found.";
    }
}
exports.SyntaxError = SyntaxError;
function peg$parse(input, options) {
    options = options !== undefined ? options : {};
    const peg$FAILED = {};
    const peg$startRuleFunctions = { start: peg$parsestart };
    let peg$startRuleFunction = peg$parsestart;
    const peg$c0 = function (negate) { return negate; };
    const peg$c1 = function (logic) { return logic; };
    const peg$c2 = function (term) { return term; };
    const peg$c3 = function (group) { return group; };
    const peg$c4 = function () {
        return {
            type: i.ASTType.Empty,
        };
    };
    const peg$c5 = function (conjunctions) {
        return {
            type: i.ASTType.LogicalGroup,
            flow: [].concat(...conjunctions)
        };
    };
    const peg$c6 = function (group) {
        return group;
    };
    const peg$c7 = function (nodes) {
        return [{
                type: i.ASTType.Conjunction,
                nodes: [].concat(...nodes),
            }];
    };
    const peg$c8 = function (nodes) {
        return nodes.reduce((prev, current) => {
            current.forEach((node) => {
                prev.push({
                    type: i.ASTType.Conjunction,
                    nodes: Array.isArray(node) ? node : [node]
                });
            });
            return prev;
        }, []);
    };
    const peg$c9 = function (left, nodes) {
        return [left, ...nodes];
    };
    const peg$c10 = "NOT";
    const peg$c11 = peg$literalExpectation("NOT", false);
    const peg$c12 = function (right, nodes) {
        if (!nodes)
            return [right];
        return [right, ...nodes];
    };
    const peg$c13 = function (left, right, nodes) {
        // if nodes exists that means the right should be joined with the next AND statements
        if (nodes) {
            return [left, [right, ...nodes]];
        }
        return [left, right];
    };
    const peg$c14 = function (right, nodes) {
        // if nodes exists that means the right should be joined with the next AND statements
        if (nodes) {
            return [[right, ...nodes]];
        }
        return [right];
    };
    const peg$c15 = function (left, right) {
        return [left, right];
    };
    const peg$c16 = function (node) {
        return {
            type: i.ASTType.Negation,
            node
        };
    };
    const peg$c17 = "!";
    const peg$c18 = peg$literalExpectation("!", false);
    const peg$c19 = function (node) {
        return node;
    };
    const peg$c20 = function (field, group) {
        const node = {
            ...group,
            type: i.ASTType.FieldGroup,
            field,
        };
        propagateDefaultField(group, field);
        return node;
    };
    const peg$c21 = function (field) {
        return {
            type: i.ASTType.Exists,
            field,
        };
    };
    const peg$c22 = function (field, range) {
        coerceTermType(range.left, field);
        coerceTermType(range.right, field);
        return {
            ...range,
            field,
        };
    };
    const peg$c23 = function (field, term) {
        const node = { ...term, field };
        coerceTermType(node, field);
        return node;
    };
    const peg$c24 = function (field, value) {
        return isInferredTermType(field);
    };
    const peg$c25 = function (field, value) {
        const term = parseInferredTermType(field, value);
        return {
            ...term,
            field,
        };
    };
    const peg$c26 = function (field, chars) {
        const key = chars.join('');
        const value = getVariable(key);
        const node = { value, field, type: i.ASTType.Term };
        coerceTermType(node, field);
        return node;
    };
    const peg$c27 = function (field, chars) {
        const key = chars.join('');
        const value = getVariable(key);
        // created quoted node for each value
        if (Array.isArray(value)) {
            // create logical group node
            const root = {
                type: i.ASTType.LogicalGroup,
                flow: makeFlow(field, value, key)
            };
            return root;
        }
        validateRestrictedVariable(value, key);
        const node = { value, field, type: i.ASTType.Term };
        coerceTermType(node, field);
        return node;
    };
    const peg$c28 = function (range) {
        return {
            ...range,
            field: null,
        };
    };
    const peg$c29 = function (term) {
        return {
            ...term,
            field: null,
        };
    };
    const peg$c30 = function (term) {
        return term;
    };
    const peg$c31 = function (field, term) {
        const { name, params } = term;
        return {
            type: i.ASTType.Function,
            name,
            instance: parseFunction(field, name, params),
            params,
            field,
        };
    };
    const peg$c32 = function (name, fnArgs) {
        const params = fnArgs || [];
        return { params, name };
    };
    const peg$c33 = function (param, params) {
        if (params)
            return [param, ...params];
        return [param];
    };
    const peg$c34 = function (field, list) {
        const value = list && list.length > 0 ? list : [];
        return {
            field,
            value
        };
    };
    const peg$c35 = function (item) {
        return item;
    };
    const peg$c36 = function (list) {
        // needs to recursive check to see if value is list
        return list;
    };
    const peg$c37 = function (field, term) {
        return {
            ...term,
            field,
        };
    };
    const peg$c38 = function (left, right) {
        return {
            type: i.ASTType.Range,
            left,
            right,
        };
    };
    const peg$c39 = function (operator, value) {
        return {
            type: i.ASTType.Range,
            left: {
                operator,
                ...value,
            },
        };
    };
    const peg$c40 = function (operator, value) {
        return {
            ...value,
            operator,
        };
    };
    const peg$c41 = function (value, operator) {
        return {
            ...value,
            operator,
        };
    };
    const peg$c42 = function (point, distance) {
        return {
            type: i.ASTType.GeoDistance,
            ...point,
            ...distance
        };
    };
    const peg$c43 = function (distance, point) {
        return {
            type: i.ASTType.GeoDistance,
            ...point,
            ...distance
        };
    };
    const peg$c44 = function (topLeft, bottomRight) {
        return {
            type: i.ASTType.GeoBoundingBox,
            ...topLeft,
            ...bottomRight
        };
    };
    const peg$c45 = function (bottomRight, topLeft) {
        return {
            type: i.ASTType.GeoBoundingBox,
            ...topLeft,
            ...bottomRight
        };
    };
    const peg$c46 = "*";
    const peg$c47 = peg$literalExpectation("*", false);
    const peg$c48 = function () {
        return {
            type: i.ASTType.Term,
            field_type: interfaces_1.FieldType.Integer,
            value: Number.NEGATIVE_INFINITY
        };
    };
    const peg$c49 = function () {
        return {
            type: i.ASTType.Term,
            field_type: interfaces_1.FieldType.Integer,
            value: Number.POSITIVE_INFINITY
        };
    };
    const peg$c50 = function (chars) {
        const key = chars.join('');
        const value = getVariable(key);
        const node = { value, type: i.ASTType.Term };
        coerceTermType(node);
        return node;
    };
    const peg$c51 = function (value) {
        return {
            type: i.ASTType.Term,
            field_type: interfaces_1.FieldType.Float,
            value
        };
    };
    const peg$c52 = function (value) {
        return {
            type: i.ASTType.Term,
            field_type: interfaces_1.FieldType.Integer,
            value
        };
    };
    const peg$c53 = "]";
    const peg$c54 = peg$literalExpectation("]", false);
    const peg$c55 = function (value) {
        return {
            type: i.ASTType.Term,
            field_type: interfaces_1.FieldType.Boolean,
            value
        };
    };
    const peg$c56 = function (value) {
        return {
            type: i.ASTType.Regexp,
            field_type: interfaces_1.FieldType.String,
            value
        };
    };
    const peg$c57 = function (value) {
        return {
            type: i.ASTType.Wildcard,
            field_type: interfaces_1.FieldType.String,
            value
        };
    };
    const peg$c58 = function (value) {
        return {
            type: i.ASTType.Term,
            field_type: interfaces_1.FieldType.String,
            quoted: true,
            value
        };
    };
    const peg$c59 = function (value) {
        return {
            type: i.ASTType.Term,
            field_type: interfaces_1.FieldType.String,
            quoted: false,
            value
        };
    };
    const peg$c60 = function (value) {
        return {
            type: i.ASTType.Term,
            field_type: interfaces_1.FieldType.String,
            restricted: true,
            quoted: false,
            value
        };
    };
    const peg$c61 = function (chars) { return chars.join(''); };
    const peg$c62 = function (term) {
        return parseGeoPoint(term.value);
    };
    const peg$c63 = function (term) {
        return parseGeoDistance(term.value);
    };
    const peg$c64 = function (term) {
        return {
            top_left: parseGeoPoint(term.value)
        };
    };
    const peg$c65 = function (term) {
        return {
            bottom_right: parseGeoPoint(term.value)
        };
    };
    const peg$c66 = function (chars) {
        return chars.join('');
    };
    const peg$c67 = "/";
    const peg$c68 = peg$literalExpectation("/", false);
    const peg$c69 = function (chars) { return chars.join(''); };
    const peg$c70 = function (int) { return parseInt(int, 10); };
    const peg$c71 = function (float) { return parseFloat(float); };
    const peg$c72 = "_exists_";
    const peg$c73 = peg$literalExpectation("_exists_", false);
    const peg$c74 = "_geo_point_";
    const peg$c75 = peg$literalExpectation("_geo_point_", false);
    const peg$c76 = "_geo_distance_";
    const peg$c77 = peg$literalExpectation("_geo_distance_", false);
    const peg$c78 = "_geo_box_top_left_";
    const peg$c79 = peg$literalExpectation("_geo_box_top_left_", false);
    const peg$c80 = "_geo_box_bottom_right_";
    const peg$c81 = peg$literalExpectation("_geo_box_bottom_right_", false);
    const peg$c82 = "true";
    const peg$c83 = peg$literalExpectation("true", false);
    const peg$c84 = function () { return true; };
    const peg$c85 = "false";
    const peg$c86 = peg$literalExpectation("false", false);
    const peg$c87 = function () { return false; };
    const peg$c88 = ">=";
    const peg$c89 = peg$literalExpectation(">=", false);
    const peg$c90 = function () { return 'gte'; };
    const peg$c91 = ">";
    const peg$c92 = peg$literalExpectation(">", false);
    const peg$c93 = function () { return 'gt'; };
    const peg$c94 = "<=";
    const peg$c95 = peg$literalExpectation("<=", false);
    const peg$c96 = function () { return 'lte'; };
    const peg$c97 = "<";
    const peg$c98 = peg$literalExpectation("<", false);
    const peg$c99 = function () { return 'lt'; };
    const peg$c100 = "[";
    const peg$c101 = peg$literalExpectation("[", false);
    const peg$c102 = "{";
    const peg$c103 = peg$literalExpectation("{", false);
    const peg$c104 = "}";
    const peg$c105 = peg$literalExpectation("}", false);
    const peg$c106 = "TO";
    const peg$c107 = peg$literalExpectation("TO", false);
    const peg$c108 = "(";
    const peg$c109 = peg$literalExpectation("(", false);
    const peg$c110 = ")";
    const peg$c111 = peg$literalExpectation(")", false);
    const peg$c112 = ",";
    const peg$c113 = peg$literalExpectation(",", false);
    const peg$c114 = peg$otherExpectation("wildcard");
    const peg$c115 = /^[^?*( ]/;
    const peg$c116 = peg$classExpectation(["?", "*", "(", " "], true, false);
    const peg$c117 = "?";
    const peg$c118 = peg$literalExpectation("?", false);
    const peg$c119 = /^[^?*) ]/;
    const peg$c120 = peg$classExpectation(["?", "*", ")", " "], true, false);
    const peg$c121 = peg$otherExpectation("field");
    const peg$c122 = /^[_a-zA-Z0-9\-.?*]/;
    const peg$c123 = peg$classExpectation(["_", ["a", "z"], ["A", "Z"], ["0", "9"], "-", ".", "?", "*"], false, false);
    const peg$c124 = /^[_a-zA-Z0-9]/;
    const peg$c125 = peg$classExpectation(["_", ["a", "z"], ["A", "Z"], ["0", "9"]], false, false);
    const peg$c126 = peg$otherExpectation("");
    const peg$c127 = ":";
    const peg$c128 = peg$literalExpectation(":", false);
    const peg$c129 = function (sequence) { return '\\' + sequence; };
    const peg$c130 = ".";
    const peg$c131 = peg$literalExpectation(".", false);
    const peg$c132 = peg$otherExpectation("term");
    const peg$c133 = /^[^:*?{}()"\/\^~[\]]/;
    const peg$c134 = peg$classExpectation([":", "*", "?", "{", "}", "(", ")", "\"", "/", "^", "~", "[", "]"], true, false);
    const peg$c135 = /^[^ \t\r\n\f{}()|\/\\\/\^~[\]&!?=<>]/;
    const peg$c136 = peg$classExpectation([" ", "\t", "\r", "\n", "\f", "{", "}", "(", ")", "|", "/", "\\", "/", "^", "~", "[", "]", "&", "!", "?", "=", "<", ">"], true, false);
    const peg$c137 = "\"";
    const peg$c138 = peg$literalExpectation("\"", false);
    const peg$c139 = "'";
    const peg$c140 = peg$literalExpectation("'", false);
    const peg$c141 = "\\";
    const peg$c142 = peg$literalExpectation("\\", false);
    const peg$c143 = peg$anyExpectation();
    const peg$c144 = function (char) { return char; };
    const peg$c145 = function (sequence) { return sequence; };
    const peg$c146 = "b";
    const peg$c147 = peg$literalExpectation("b", false);
    const peg$c148 = function () { return "\b"; };
    const peg$c149 = "f";
    const peg$c150 = peg$literalExpectation("f", false);
    const peg$c151 = function () { return "\f"; };
    const peg$c152 = "n";
    const peg$c153 = peg$literalExpectation("n", false);
    const peg$c154 = function () { return "\n"; };
    const peg$c155 = "r";
    const peg$c156 = peg$literalExpectation("r", false);
    const peg$c157 = function () { return "\r"; };
    const peg$c158 = "t";
    const peg$c159 = peg$literalExpectation("t", false);
    const peg$c160 = function () { return "\t"; };
    const peg$c161 = "v";
    const peg$c162 = peg$literalExpectation("v", false);
    const peg$c163 = function () { return "\x0B"; };
    const peg$c164 = "AND";
    const peg$c165 = peg$literalExpectation("AND", false);
    const peg$c166 = "&&";
    const peg$c167 = peg$literalExpectation("&&", false);
    const peg$c168 = "OR";
    const peg$c169 = peg$literalExpectation("OR", false);
    const peg$c170 = "||";
    const peg$c171 = peg$literalExpectation("||", false);
    const peg$c172 = "0";
    const peg$c173 = peg$literalExpectation("0", false);
    const peg$c174 = peg$otherExpectation("a character between 1-9");
    const peg$c175 = /^[1-9]/;
    const peg$c176 = peg$classExpectation([["1", "9"]], false, false);
    const peg$c177 = peg$otherExpectation("a character between 0-9");
    const peg$c178 = /^[0-9]/;
    const peg$c179 = peg$classExpectation([["0", "9"]], false, false);
    const peg$c180 = "$";
    const peg$c181 = peg$literalExpectation("$", false);
    const peg$c182 = " ";
    const peg$c183 = peg$literalExpectation(" ", false);
    const peg$c184 = "+";
    const peg$c185 = peg$literalExpectation("+", false);
    const peg$c186 = "-";
    const peg$c187 = peg$literalExpectation("-", false);
    const peg$c188 = "^";
    const peg$c189 = peg$literalExpectation("^", false);
    const peg$c190 = "&";
    const peg$c191 = peg$literalExpectation("&", false);
    const peg$c192 = "|";
    const peg$c193 = peg$literalExpectation("|", false);
    const peg$c194 = "~";
    const peg$c195 = peg$literalExpectation("~", false);
    const peg$c196 = peg$otherExpectation("whitespace");
    const peg$c197 = "\t";
    const peg$c198 = peg$literalExpectation("\t", false);
    const peg$c199 = "\x0B";
    const peg$c200 = peg$literalExpectation("\x0B", false);
    const peg$c201 = "\f";
    const peg$c202 = peg$literalExpectation("\f", false);
    let peg$currPos = 0;
    let peg$savedPos = 0;
    const peg$posDetailsCache = [{ line: 1, column: 1 }];
    let peg$maxFailPos = 0;
    let peg$maxFailExpected = [];
    let peg$silentFails = 0;
    let peg$result;
    if (options.startRule !== undefined) {
        if (!(options.startRule in peg$startRuleFunctions)) {
            throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
        }
        peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
    }
    function text() {
        return input.substring(peg$savedPos, peg$currPos);
    }
    function location() {
        return peg$computeLocation(peg$savedPos, peg$currPos);
    }
    function expected(description, location1) {
        location1 = location1 !== undefined
            ? location1
            : peg$computeLocation(peg$savedPos, peg$currPos);
        throw peg$buildStructuredError([peg$otherExpectation(description)], input.substring(peg$savedPos, peg$currPos), location1);
    }
    function error(message, location1) {
        location1 = location1 !== undefined
            ? location1
            : peg$computeLocation(peg$savedPos, peg$currPos);
        throw peg$buildSimpleError(message, location1);
    }
    function peg$literalExpectation(text1, ignoreCase) {
        return { type: "literal", text: text1, ignoreCase: ignoreCase };
    }
    function peg$classExpectation(parts, inverted, ignoreCase) {
        return { type: "class", parts: parts, inverted: inverted, ignoreCase: ignoreCase };
    }
    function peg$anyExpectation() {
        return { type: "any" };
    }
    function peg$endExpectation() {
        return { type: "end" };
    }
    function peg$otherExpectation(description) {
        return { type: "other", description: description };
    }
    function peg$computePosDetails(pos) {
        let details = peg$posDetailsCache[pos];
        let p;
        if (details) {
            return details;
        }
        else {
            p = pos - 1;
            while (!peg$posDetailsCache[p]) {
                p--;
            }
            details = peg$posDetailsCache[p];
            details = {
                line: details.line,
                column: details.column
            };
            while (p < pos) {
                if (input.charCodeAt(p) === 10) {
                    details.line++;
                    details.column = 1;
                }
                else {
                    details.column++;
                }
                p++;
            }
            peg$posDetailsCache[pos] = details;
            return details;
        }
    }
    function peg$computeLocation(startPos, endPos) {
        const startPosDetails = peg$computePosDetails(startPos);
        const endPosDetails = peg$computePosDetails(endPos);
        return {
            start: {
                offset: startPos,
                line: startPosDetails.line,
                column: startPosDetails.column
            },
            end: {
                offset: endPos,
                line: endPosDetails.line,
                column: endPosDetails.column
            }
        };
    }
    function peg$fail(expected1) {
        if (peg$currPos < peg$maxFailPos) {
            return;
        }
        if (peg$currPos > peg$maxFailPos) {
            peg$maxFailPos = peg$currPos;
            peg$maxFailExpected = [];
        }
        peg$maxFailExpected.push(expected1);
    }
    function peg$buildSimpleError(message, location1) {
        return new SyntaxError(message, [], "", location1);
    }
    function peg$buildStructuredError(expected1, found, location1) {
        return new SyntaxError(SyntaxError.buildMessage(expected1, found), expected1, found, location1);
    }
    function peg$parsestart() {
        let s0, s1, s2, s3, s4;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parsews();
        while (s2 !== peg$FAILED) {
            s1.push(s2);
            s2 = peg$parsews();
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$parseNegationExpression();
            if (s2 !== peg$FAILED) {
                s3 = [];
                s4 = peg$parsews();
                while (s4 !== peg$FAILED) {
                    s3.push(s4);
                    s4 = peg$parsews();
                }
                if (s3 !== peg$FAILED) {
                    s4 = peg$parseEOF();
                    if (s4 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1 = peg$c0(s2);
                        s0 = s1;
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = [];
            s2 = peg$parsews();
            while (s2 !== peg$FAILED) {
                s1.push(s2);
                s2 = peg$parsews();
            }
            if (s1 !== peg$FAILED) {
                s2 = peg$parseLogicalGroup();
                if (s2 !== peg$FAILED) {
                    s3 = [];
                    s4 = peg$parsews();
                    while (s4 !== peg$FAILED) {
                        s3.push(s4);
                        s4 = peg$parsews();
                    }
                    if (s3 !== peg$FAILED) {
                        s4 = peg$parseEOF();
                        if (s4 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c1(s2);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
            if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = [];
                s2 = peg$parsews();
                while (s2 !== peg$FAILED) {
                    s1.push(s2);
                    s2 = peg$parsews();
                }
                if (s1 !== peg$FAILED) {
                    s2 = peg$parseTermExpression();
                    if (s2 !== peg$FAILED) {
                        s3 = [];
                        s4 = peg$parsews();
                        while (s4 !== peg$FAILED) {
                            s3.push(s4);
                            s4 = peg$parsews();
                        }
                        if (s3 !== peg$FAILED) {
                            s4 = peg$parseEOF();
                            if (s4 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c2(s2);
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    s1 = [];
                    s2 = peg$parsews();
                    while (s2 !== peg$FAILED) {
                        s1.push(s2);
                        s2 = peg$parsews();
                    }
                    if (s1 !== peg$FAILED) {
                        s2 = peg$parseUnqoutedTermType();
                        if (s2 !== peg$FAILED) {
                            s3 = [];
                            s4 = peg$parsews();
                            while (s4 !== peg$FAILED) {
                                s3.push(s4);
                                s4 = peg$parsews();
                            }
                            if (s3 !== peg$FAILED) {
                                s4 = peg$parseEOF();
                                if (s4 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1 = peg$c2(s2);
                                    s0 = s1;
                                }
                                else {
                                    peg$currPos = s0;
                                    s0 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                    if (s0 === peg$FAILED) {
                        s0 = peg$currPos;
                        s1 = [];
                        s2 = peg$parsews();
                        while (s2 !== peg$FAILED) {
                            s1.push(s2);
                            s2 = peg$parsews();
                        }
                        if (s1 !== peg$FAILED) {
                            s2 = peg$parseParensGroup();
                            if (s2 !== peg$FAILED) {
                                s3 = [];
                                s4 = peg$parsews();
                                while (s4 !== peg$FAILED) {
                                    s3.push(s4);
                                    s4 = peg$parsews();
                                }
                                if (s3 !== peg$FAILED) {
                                    s4 = peg$parseEOF();
                                    if (s4 !== peg$FAILED) {
                                        peg$savedPos = s0;
                                        s1 = peg$c3(s2);
                                        s0 = s1;
                                    }
                                    else {
                                        peg$currPos = s0;
                                        s0 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s0;
                                    s0 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                        if (s0 === peg$FAILED) {
                            s0 = peg$currPos;
                            s1 = [];
                            s2 = peg$parsews();
                            while (s2 !== peg$FAILED) {
                                s1.push(s2);
                                s2 = peg$parsews();
                            }
                            if (s1 !== peg$FAILED) {
                                s2 = peg$parseEOF();
                                if (s2 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1 = peg$c4();
                                    s0 = s1;
                                }
                                else {
                                    peg$currPos = s0;
                                    s0 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                    }
                }
            }
        }
        return s0;
    }
    function peg$parseLogicalGroup() {
        let s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$currPos;
        peg$silentFails++;
        s2 = peg$parseConjunctionOperator();
        peg$silentFails--;
        if (s2 === peg$FAILED) {
            s1 = undefined;
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parseConjunction();
            if (s3 !== peg$FAILED) {
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parseConjunction();
                }
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c5(s2);
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseParensGroup() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseParensStart();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseParensGroup();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseParensEnd();
                        if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c6(s3);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseParensStart();
            if (s1 !== peg$FAILED) {
                s2 = [];
                s3 = peg$parsews();
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parsews();
                }
                if (s2 !== peg$FAILED) {
                    s3 = peg$parseLogicalGroup();
                    if (s3 !== peg$FAILED) {
                        s4 = [];
                        s5 = peg$parsews();
                        while (s5 !== peg$FAILED) {
                            s4.push(s5);
                            s5 = peg$parsews();
                        }
                        if (s4 !== peg$FAILED) {
                            s5 = peg$parseParensEnd();
                            if (s5 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c6(s3);
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        return s0;
    }
    function peg$parseConjunction() {
        let s0, s1, s2;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parseAndConjunctionStart();
        if (s2 !== peg$FAILED) {
            while (s2 !== peg$FAILED) {
                s1.push(s2);
                s2 = peg$parseAndConjunctionStart();
            }
        }
        else {
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c7(s1);
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = [];
            s2 = peg$parseOrConjunction();
            if (s2 !== peg$FAILED) {
                while (s2 !== peg$FAILED) {
                    s1.push(s2);
                    s2 = peg$parseOrConjunction();
                }
            }
            else {
                s1 = peg$FAILED;
            }
            if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c8(s1);
            }
            s0 = s1;
        }
        return s0;
    }
    function peg$parseAndConjunctionStart() {
        let s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$parseTermGroup();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            if (s3 !== peg$FAILED) {
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parsews();
                }
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseAndConjunction();
                if (s3 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c9(s1, s3);
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseAndConjunction() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parsews();
        while (s2 !== peg$FAILED) {
            s1.push(s2);
            s2 = peg$parsews();
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            peg$silentFails++;
            if (input.substr(peg$currPos, 3) === peg$c10) {
                s3 = peg$c10;
                peg$currPos += 3;
            }
            else {
                s3 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c11);
                }
            }
            peg$silentFails--;
            if (s3 !== peg$FAILED) {
                peg$currPos = s2;
                s2 = undefined;
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s3 = [];
                s4 = peg$parsews();
                while (s4 !== peg$FAILED) {
                    s3.push(s4);
                    s4 = peg$parsews();
                }
                if (s3 !== peg$FAILED) {
                    s4 = peg$parseTermGroup();
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseAndConjunction();
                        if (s5 === peg$FAILED) {
                            s5 = null;
                        }
                        if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c12(s4, s5);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = [];
            s2 = peg$parsews();
            while (s2 !== peg$FAILED) {
                s1.push(s2);
                s2 = peg$parsews();
            }
            if (s1 !== peg$FAILED) {
                s2 = peg$parseAndConjunctionOperator();
                if (s2 !== peg$FAILED) {
                    s3 = [];
                    s4 = peg$parsews();
                    if (s4 !== peg$FAILED) {
                        while (s4 !== peg$FAILED) {
                            s3.push(s4);
                            s4 = peg$parsews();
                        }
                    }
                    else {
                        s3 = peg$FAILED;
                    }
                    if (s3 !== peg$FAILED) {
                        s4 = peg$parseTermGroup();
                        if (s4 !== peg$FAILED) {
                            s5 = peg$parseAndConjunction();
                            if (s5 === peg$FAILED) {
                                s5 = null;
                            }
                            if (s5 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c12(s4, s5);
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        return s0;
    }
    function peg$parseOrConjunction() {
        let s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$parseTermGroup();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            if (s3 !== peg$FAILED) {
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parsews();
                }
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseOrConjunctionOperator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    if (s5 !== peg$FAILED) {
                        while (s5 !== peg$FAILED) {
                            s4.push(s5);
                            s5 = peg$parsews();
                        }
                    }
                    else {
                        s4 = peg$FAILED;
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseTermGroup();
                        if (s5 !== peg$FAILED) {
                            s6 = peg$parseAndConjunction();
                            if (s6 === peg$FAILED) {
                                s6 = null;
                            }
                            if (s6 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c13(s1, s5, s6);
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = [];
            s2 = peg$parsews();
            if (s2 !== peg$FAILED) {
                while (s2 !== peg$FAILED) {
                    s1.push(s2);
                    s2 = peg$parsews();
                }
            }
            else {
                s1 = peg$FAILED;
            }
            if (s1 !== peg$FAILED) {
                s2 = peg$parseOrConjunctionOperator();
                if (s2 !== peg$FAILED) {
                    s3 = [];
                    s4 = peg$parsews();
                    if (s4 !== peg$FAILED) {
                        while (s4 !== peg$FAILED) {
                            s3.push(s4);
                            s4 = peg$parsews();
                        }
                    }
                    else {
                        s3 = peg$FAILED;
                    }
                    if (s3 !== peg$FAILED) {
                        s4 = peg$parseTermGroup();
                        if (s4 !== peg$FAILED) {
                            s5 = peg$parseAndConjunction();
                            if (s5 === peg$FAILED) {
                                s5 = null;
                            }
                            if (s5 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c14(s4, s5);
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
            if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = peg$parseFieldOrQuotedTermGroup();
                if (s1 !== peg$FAILED) {
                    s2 = [];
                    s3 = peg$parsews();
                    if (s3 !== peg$FAILED) {
                        while (s3 !== peg$FAILED) {
                            s2.push(s3);
                            s3 = peg$parsews();
                        }
                    }
                    else {
                        s2 = peg$FAILED;
                    }
                    if (s2 !== peg$FAILED) {
                        s3 = peg$parseFieldOrQuotedTermGroup();
                        if (s3 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c15(s1, s3);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    s1 = peg$parseFieldOrQuotedTermGroup();
                    if (s1 !== peg$FAILED) {
                        s2 = [];
                        s3 = peg$parsews();
                        if (s3 !== peg$FAILED) {
                            while (s3 !== peg$FAILED) {
                                s2.push(s3);
                                s3 = peg$parsews();
                            }
                        }
                        else {
                            s2 = peg$FAILED;
                        }
                        if (s2 !== peg$FAILED) {
                            s3 = peg$parseTermGroup();
                            if (s3 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c15(s1, s3);
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                    if (s0 === peg$FAILED) {
                        s0 = peg$currPos;
                        s1 = peg$parseTermGroup();
                        if (s1 !== peg$FAILED) {
                            s2 = [];
                            s3 = peg$parsews();
                            if (s3 !== peg$FAILED) {
                                while (s3 !== peg$FAILED) {
                                    s2.push(s3);
                                    s3 = peg$parsews();
                                }
                            }
                            else {
                                s2 = peg$FAILED;
                            }
                            if (s2 !== peg$FAILED) {
                                s3 = peg$parseFieldOrQuotedTermGroup();
                                if (s3 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1 = peg$c15(s1, s3);
                                    s0 = s1;
                                }
                                else {
                                    peg$currPos = s0;
                                    s0 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                }
            }
        }
        return s0;
    }
    function peg$parseTermGroup() {
        let s0;
        s0 = peg$parseNegationExpression();
        if (s0 === peg$FAILED) {
            s0 = peg$parseParensGroup();
            if (s0 === peg$FAILED) {
                s0 = peg$parseVariableType();
                if (s0 === peg$FAILED) {
                    s0 = peg$parseTermExpression();
                }
            }
        }
        return s0;
    }
    function peg$parseFieldOrQuotedTermGroup() {
        let s0;
        s0 = peg$parseParensGroup();
        if (s0 === peg$FAILED) {
            s0 = peg$parseVariableType();
            if (s0 === peg$FAILED) {
                s0 = peg$parseFieldOrQuotedTermExpression();
            }
        }
        return s0;
    }
    function peg$parseNegationExpression() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        if (input.substr(peg$currPos, 3) === peg$c10) {
            s1 = peg$c10;
            peg$currPos += 3;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c11);
            }
        }
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            if (s3 !== peg$FAILED) {
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parsews();
                }
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseNegatedTermGroup();
                if (s3 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c16(s3);
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 33) {
                s1 = peg$c17;
                peg$currPos++;
            }
            else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c18);
                }
            }
            if (s1 !== peg$FAILED) {
                s2 = [];
                s3 = peg$parsews();
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parsews();
                }
                if (s2 !== peg$FAILED) {
                    s3 = peg$parseNegatedTermGroup();
                    if (s3 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1 = peg$c16(s3);
                        s0 = s1;
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
            if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = peg$parseParensStart();
                if (s1 !== peg$FAILED) {
                    s2 = [];
                    s3 = peg$parsews();
                    while (s3 !== peg$FAILED) {
                        s2.push(s3);
                        s3 = peg$parsews();
                    }
                    if (s2 !== peg$FAILED) {
                        s3 = peg$parseNegationExpression();
                        if (s3 !== peg$FAILED) {
                            s4 = [];
                            s5 = peg$parsews();
                            while (s5 !== peg$FAILED) {
                                s4.push(s5);
                                s5 = peg$parsews();
                            }
                            if (s4 !== peg$FAILED) {
                                s5 = peg$parseParensEnd();
                                if (s5 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1 = peg$c19(s3);
                                    s0 = s1;
                                }
                                else {
                                    peg$currPos = s0;
                                    s0 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
        }
        return s0;
    }
    function peg$parseNegatedTermGroup() {
        let s0;
        s0 = peg$parseParensGroup();
        if (s0 === peg$FAILED) {
            s0 = peg$parseTermExpression();
        }
        return s0;
    }
    function peg$parseFieldGroup() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseFieldName();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseFieldSeparator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseParensGroup();
                        if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c20(s1, s5);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseBaseTermExpression() {
        let s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$parseExistsKeyword();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseFieldSeparator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseFieldName();
                        if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c21(s5);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$parseRestrictedVariableExpression();
            if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = peg$parseFieldName();
                if (s1 !== peg$FAILED) {
                    s2 = [];
                    s3 = peg$parsews();
                    while (s3 !== peg$FAILED) {
                        s2.push(s3);
                        s3 = peg$parsews();
                    }
                    if (s2 !== peg$FAILED) {
                        s3 = peg$parseFieldSeparator();
                        if (s3 !== peg$FAILED) {
                            s4 = [];
                            s5 = peg$parsews();
                            while (s5 !== peg$FAILED) {
                                s4.push(s5);
                                s5 = peg$parsews();
                            }
                            if (s4 !== peg$FAILED) {
                                s5 = peg$parseRangeExpression();
                                if (s5 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1 = peg$c22(s1, s5);
                                    s0 = s1;
                                }
                                else {
                                    peg$currPos = s0;
                                    s0 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    s1 = peg$parseFieldName();
                    if (s1 !== peg$FAILED) {
                        s2 = [];
                        s3 = peg$parsews();
                        while (s3 !== peg$FAILED) {
                            s2.push(s3);
                            s3 = peg$parsews();
                        }
                        if (s2 !== peg$FAILED) {
                            s3 = peg$parseFieldSeparator();
                            if (s3 !== peg$FAILED) {
                                s4 = [];
                                s5 = peg$parsews();
                                while (s5 !== peg$FAILED) {
                                    s4.push(s5);
                                    s5 = peg$parsews();
                                }
                                if (s4 !== peg$FAILED) {
                                    s5 = peg$parseRegexpType();
                                    if (s5 === peg$FAILED) {
                                        s5 = peg$parseQuotedStringType();
                                    }
                                    if (s5 !== peg$FAILED) {
                                        peg$savedPos = s0;
                                        s1 = peg$c23(s1, s5);
                                        s0 = s1;
                                    }
                                    else {
                                        peg$currPos = s0;
                                        s0 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s0;
                                    s0 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                    if (s0 === peg$FAILED) {
                        s0 = peg$parseFunctionExpression();
                        if (s0 === peg$FAILED) {
                            s0 = peg$parseOldGeoTermExpression();
                            if (s0 === peg$FAILED) {
                                s0 = peg$parseFieldGroup();
                                if (s0 === peg$FAILED) {
                                    s0 = peg$currPos;
                                    s1 = peg$parseFieldName();
                                    if (s1 !== peg$FAILED) {
                                        s2 = [];
                                        s3 = peg$parsews();
                                        while (s3 !== peg$FAILED) {
                                            s2.push(s3);
                                            s3 = peg$parsews();
                                        }
                                        if (s2 !== peg$FAILED) {
                                            s3 = peg$parseFieldSeparator();
                                            if (s3 !== peg$FAILED) {
                                                s4 = [];
                                                s5 = peg$parsews();
                                                while (s5 !== peg$FAILED) {
                                                    s4.push(s5);
                                                    s5 = peg$parsews();
                                                }
                                                if (s4 !== peg$FAILED) {
                                                    s5 = peg$parseParensStringType();
                                                    if (s5 === peg$FAILED) {
                                                        s5 = peg$parseWildcardType();
                                                    }
                                                    if (s5 !== peg$FAILED) {
                                                        peg$savedPos = s0;
                                                        s1 = peg$c23(s1, s5);
                                                        s0 = s1;
                                                    }
                                                    else {
                                                        peg$currPos = s0;
                                                        s0 = peg$FAILED;
                                                    }
                                                }
                                                else {
                                                    peg$currPos = s0;
                                                    s0 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s0;
                                                s0 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s0;
                                            s0 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s0;
                                        s0 = peg$FAILED;
                                    }
                                    if (s0 === peg$FAILED) {
                                        s0 = peg$currPos;
                                        s1 = peg$parseFieldName();
                                        if (s1 !== peg$FAILED) {
                                            s2 = [];
                                            s3 = peg$parsews();
                                            while (s3 !== peg$FAILED) {
                                                s2.push(s3);
                                                s3 = peg$parsews();
                                            }
                                            if (s2 !== peg$FAILED) {
                                                s3 = peg$parseFieldSeparator();
                                                if (s3 !== peg$FAILED) {
                                                    s4 = [];
                                                    s5 = peg$parsews();
                                                    while (s5 !== peg$FAILED) {
                                                        s4.push(s5);
                                                        s5 = peg$parsews();
                                                    }
                                                    if (s4 !== peg$FAILED) {
                                                        s5 = peg$parseRestrictedString();
                                                        if (s5 !== peg$FAILED) {
                                                            peg$savedPos = peg$currPos;
                                                            s6 = peg$c24(s1, s5);
                                                            if (s6) {
                                                                s6 = undefined;
                                                            }
                                                            else {
                                                                s6 = peg$FAILED;
                                                            }
                                                            if (s6 !== peg$FAILED) {
                                                                peg$savedPos = s0;
                                                                s1 = peg$c25(s1, s5);
                                                                s0 = s1;
                                                            }
                                                            else {
                                                                peg$currPos = s0;
                                                                s0 = peg$FAILED;
                                                            }
                                                        }
                                                        else {
                                                            peg$currPos = s0;
                                                            s0 = peg$FAILED;
                                                        }
                                                    }
                                                    else {
                                                        peg$currPos = s0;
                                                        s0 = peg$FAILED;
                                                    }
                                                }
                                                else {
                                                    peg$currPos = s0;
                                                    s0 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s0;
                                                s0 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s0;
                                            s0 = peg$FAILED;
                                        }
                                        if (s0 === peg$FAILED) {
                                            s0 = peg$currPos;
                                            s1 = peg$parseFieldName();
                                            if (s1 !== peg$FAILED) {
                                                s2 = [];
                                                s3 = peg$parsews();
                                                while (s3 !== peg$FAILED) {
                                                    s2.push(s3);
                                                    s3 = peg$parsews();
                                                }
                                                if (s2 !== peg$FAILED) {
                                                    s3 = peg$parseFieldSeparator();
                                                    if (s3 !== peg$FAILED) {
                                                        s4 = [];
                                                        s5 = peg$parsews();
                                                        while (s5 !== peg$FAILED) {
                                                            s4.push(s5);
                                                            s5 = peg$parsews();
                                                        }
                                                        if (s4 !== peg$FAILED) {
                                                            s5 = peg$parseBooleanType();
                                                            if (s5 === peg$FAILED) {
                                                                s5 = peg$parseFloatType();
                                                                if (s5 === peg$FAILED) {
                                                                    s5 = peg$parseIntegerType();
                                                                    if (s5 === peg$FAILED) {
                                                                        s5 = peg$parseRestrictedStringType();
                                                                    }
                                                                }
                                                            }
                                                            if (s5 !== peg$FAILED) {
                                                                peg$savedPos = s0;
                                                                s1 = peg$c23(s1, s5);
                                                                s0 = s1;
                                                            }
                                                            else {
                                                                peg$currPos = s0;
                                                                s0 = peg$FAILED;
                                                            }
                                                        }
                                                        else {
                                                            peg$currPos = s0;
                                                            s0 = peg$FAILED;
                                                        }
                                                    }
                                                    else {
                                                        peg$currPos = s0;
                                                        s0 = peg$FAILED;
                                                    }
                                                }
                                                else {
                                                    peg$currPos = s0;
                                                    s0 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s0;
                                                s0 = peg$FAILED;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return s0;
    }
    function peg$parseVariableExpression() {
        let s0, s1, s2, s3, s4, s5, s6, s7;
        s0 = peg$currPos;
        s1 = peg$parseFieldName();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseFieldSeparator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseVariableSign();
                        if (s5 !== peg$FAILED) {
                            s6 = [];
                            s7 = peg$parseVariableChar();
                            if (s7 !== peg$FAILED) {
                                while (s7 !== peg$FAILED) {
                                    s6.push(s7);
                                    s7 = peg$parseVariableChar();
                                }
                            }
                            else {
                                s6 = peg$FAILED;
                            }
                            if (s6 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c26(s1, s6);
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseRestrictedVariableExpression() {
        let s0, s1, s2, s3, s4, s5, s6, s7;
        s0 = peg$currPos;
        s1 = peg$parseFieldName();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseFieldSeparator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseVariableSign();
                        if (s5 !== peg$FAILED) {
                            s6 = [];
                            s7 = peg$parseVariableChar();
                            if (s7 !== peg$FAILED) {
                                while (s7 !== peg$FAILED) {
                                    s6.push(s7);
                                    s7 = peg$parseVariableChar();
                                }
                            }
                            else {
                                s6 = peg$FAILED;
                            }
                            if (s6 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c27(s1, s6);
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseTermExpression() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$parseBaseTermExpression();
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseRangeExpression();
            if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c28(s1);
            }
            s0 = s1;
            if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = peg$parseTermType();
                if (s1 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c29(s1);
                }
                s0 = s1;
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    s1 = peg$parseParensStart();
                    if (s1 !== peg$FAILED) {
                        s2 = [];
                        s3 = peg$parsews();
                        while (s3 !== peg$FAILED) {
                            s2.push(s3);
                            s3 = peg$parsews();
                        }
                        if (s2 !== peg$FAILED) {
                            s3 = peg$parseTermExpression();
                            if (s3 !== peg$FAILED) {
                                s4 = [];
                                s5 = peg$parsews();
                                while (s5 !== peg$FAILED) {
                                    s4.push(s5);
                                    s5 = peg$parsews();
                                }
                                if (s4 !== peg$FAILED) {
                                    s5 = peg$parseParensEnd();
                                    if (s5 !== peg$FAILED) {
                                        peg$savedPos = s0;
                                        s1 = peg$c30(s3);
                                        s0 = s1;
                                    }
                                    else {
                                        peg$currPos = s0;
                                        s0 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s0;
                                    s0 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
            }
        }
        return s0;
    }
    function peg$parseFieldOrQuotedTermExpression() {
        let s0, s1;
        s0 = peg$parseBaseTermExpression();
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseQuotedStringType();
            if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c29(s1);
            }
            s0 = s1;
        }
        return s0;
    }
    function peg$parseFunctionExpression() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseFieldName();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseFieldSeparator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseFunctionTerm();
                        if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c31(s1, s5);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseFunctionTerm() {
        let s0, s1, s2, s3, s4, s5, s6, s7;
        s0 = peg$currPos;
        s1 = peg$parseRestrictedString();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseParensStart();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseFunctionParams();
                        if (s5 === peg$FAILED) {
                            s5 = null;
                        }
                        if (s5 !== peg$FAILED) {
                            s6 = [];
                            s7 = peg$parsews();
                            while (s7 !== peg$FAILED) {
                                s6.push(s7);
                                s7 = peg$parsews();
                            }
                            if (s6 !== peg$FAILED) {
                                s7 = peg$parseParensEnd();
                                if (s7 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1 = peg$c32(s1, s5);
                                    s0 = s1;
                                }
                                else {
                                    peg$currPos = s0;
                                    s0 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseFunctionParams() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseListExpression();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = [];
                s4 = peg$parseComma();
                while (s4 !== peg$FAILED) {
                    s3.push(s4);
                    s4 = peg$parseComma();
                }
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseFunctionParams();
                        if (s5 === peg$FAILED) {
                            s5 = null;
                        }
                        if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c33(s1, s5);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseFunctionTermExpression();
            if (s1 !== peg$FAILED) {
                s2 = [];
                s3 = peg$parsews();
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parsews();
                }
                if (s2 !== peg$FAILED) {
                    s3 = [];
                    s4 = peg$parseComma();
                    while (s4 !== peg$FAILED) {
                        s3.push(s4);
                        s4 = peg$parseComma();
                    }
                    if (s3 !== peg$FAILED) {
                        s4 = [];
                        s5 = peg$parsews();
                        while (s5 !== peg$FAILED) {
                            s4.push(s5);
                            s5 = peg$parsews();
                        }
                        if (s4 !== peg$FAILED) {
                            s5 = peg$parseFunctionParams();
                            if (s5 === peg$FAILED) {
                                s5 = null;
                            }
                            if (s5 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c33(s1, s5);
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        return s0;
    }
    function peg$parseFunctionTermExpression() {
        let s0;
        s0 = peg$parseVariableExpression();
        if (s0 === peg$FAILED) {
            s0 = peg$parseTermExpression();
        }
        return s0;
    }
    function peg$parseListExpression() {
        let s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;
        s0 = peg$currPos;
        s1 = peg$parseFieldName();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseFieldSeparator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseListStart();
                        if (s5 !== peg$FAILED) {
                            s6 = [];
                            s7 = peg$parsews();
                            while (s7 !== peg$FAILED) {
                                s6.push(s7);
                                s7 = peg$parsews();
                            }
                            if (s6 !== peg$FAILED) {
                                s7 = [];
                                s8 = peg$parseListItem();
                                while (s8 !== peg$FAILED) {
                                    s7.push(s8);
                                    s8 = peg$parseListItem();
                                }
                                if (s7 !== peg$FAILED) {
                                    s8 = [];
                                    s9 = peg$parsews();
                                    while (s9 !== peg$FAILED) {
                                        s8.push(s9);
                                        s9 = peg$parsews();
                                    }
                                    if (s8 !== peg$FAILED) {
                                        s9 = peg$parseListEnd();
                                        if (s9 !== peg$FAILED) {
                                            peg$savedPos = s0;
                                            s1 = peg$c34(s1, s7);
                                            s0 = s1;
                                        }
                                        else {
                                            peg$currPos = s0;
                                            s0 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s0;
                                        s0 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s0;
                                    s0 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseListItem() {
        let s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parsews();
        while (s2 !== peg$FAILED) {
            s1.push(s2);
            s2 = peg$parsews();
        }
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parseComma();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parseComma();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseTermExpression();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = [];
                        s6 = peg$parseComma();
                        while (s6 !== peg$FAILED) {
                            s5.push(s6);
                            s6 = peg$parseComma();
                        }
                        if (s5 !== peg$FAILED) {
                            s6 = [];
                            s7 = peg$parsews();
                            while (s7 !== peg$FAILED) {
                                s6.push(s7);
                                s7 = peg$parsews();
                            }
                            if (s6 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c35(s3);
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = [];
            s2 = peg$parsews();
            while (s2 !== peg$FAILED) {
                s1.push(s2);
                s2 = peg$parsews();
            }
            if (s1 !== peg$FAILED) {
                s2 = [];
                s3 = peg$parseComma();
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parseComma();
                }
                if (s2 !== peg$FAILED) {
                    s3 = peg$parseListStart();
                    if (s3 !== peg$FAILED) {
                        s4 = [];
                        s5 = peg$parsews();
                        while (s5 !== peg$FAILED) {
                            s4.push(s5);
                            s5 = peg$parsews();
                        }
                        if (s4 !== peg$FAILED) {
                            s5 = [];
                            s6 = peg$parseListItem();
                            while (s6 !== peg$FAILED) {
                                s5.push(s6);
                                s6 = peg$parseListItem();
                            }
                            if (s5 !== peg$FAILED) {
                                s6 = [];
                                s7 = peg$parsews();
                                while (s7 !== peg$FAILED) {
                                    s6.push(s7);
                                    s7 = peg$parsews();
                                }
                                if (s6 !== peg$FAILED) {
                                    s7 = peg$parseListEnd();
                                    if (s7 !== peg$FAILED) {
                                        s8 = [];
                                        s9 = peg$parsews();
                                        while (s9 !== peg$FAILED) {
                                            s8.push(s9);
                                            s9 = peg$parsews();
                                        }
                                        if (s8 !== peg$FAILED) {
                                            s9 = [];
                                            s10 = peg$parseComma();
                                            while (s10 !== peg$FAILED) {
                                                s9.push(s10);
                                                s10 = peg$parseComma();
                                            }
                                            if (s9 !== peg$FAILED) {
                                                s10 = [];
                                                s11 = peg$parsews();
                                                while (s11 !== peg$FAILED) {
                                                    s10.push(s11);
                                                    s11 = peg$parsews();
                                                }
                                                if (s10 !== peg$FAILED) {
                                                    peg$savedPos = s0;
                                                    s1 = peg$c36(s5);
                                                    s0 = s1;
                                                }
                                                else {
                                                    peg$currPos = s0;
                                                    s0 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s0;
                                                s0 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s0;
                                            s0 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s0;
                                        s0 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s0;
                                    s0 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        return s0;
    }
    function peg$parseOldGeoTermExpression() {
        let s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;
        s0 = peg$currPos;
        s1 = peg$parseFieldName();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseFieldSeparator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseParensStart();
                        if (s5 !== peg$FAILED) {
                            s6 = [];
                            s7 = peg$parsews();
                            while (s7 !== peg$FAILED) {
                                s6.push(s7);
                                s7 = peg$parsews();
                            }
                            if (s6 !== peg$FAILED) {
                                s7 = peg$parseOldGeoTermType();
                                if (s7 !== peg$FAILED) {
                                    s8 = [];
                                    s9 = peg$parsews();
                                    while (s9 !== peg$FAILED) {
                                        s8.push(s9);
                                        s9 = peg$parsews();
                                    }
                                    if (s8 !== peg$FAILED) {
                                        s9 = peg$parseParensEnd();
                                        if (s9 !== peg$FAILED) {
                                            peg$savedPos = s0;
                                            s1 = peg$c37(s1, s7);
                                            s0 = s1;
                                        }
                                        else {
                                            peg$currPos = s0;
                                            s0 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s0;
                                        s0 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s0;
                                    s0 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseParensStringType() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseParensStart();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseQuotedStringType();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseParensEnd();
                        if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c30(s3);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseParensStart();
            if (s1 !== peg$FAILED) {
                s2 = [];
                s3 = peg$parsews();
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parsews();
                }
                if (s2 !== peg$FAILED) {
                    s3 = peg$parseUnqoutedStringType();
                    if (s3 !== peg$FAILED) {
                        s4 = [];
                        s5 = peg$parsews();
                        while (s5 !== peg$FAILED) {
                            s4.push(s5);
                            s5 = peg$parsews();
                        }
                        if (s4 !== peg$FAILED) {
                            s5 = peg$parseParensEnd();
                            if (s5 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c30(s3);
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        return s0;
    }
    function peg$parseUnqoutedTermType() {
        let s0, s1;
        s0 = peg$currPos;
        s1 = peg$parseUnqoutedStringType();
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c29(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseRangeExpression() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseLeftRangeExpression();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            if (s3 !== peg$FAILED) {
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parsews();
                }
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseRangeJoinOperator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    if (s5 !== peg$FAILED) {
                        while (s5 !== peg$FAILED) {
                            s4.push(s5);
                            s5 = peg$parsews();
                        }
                    }
                    else {
                        s4 = peg$FAILED;
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseRightRangeExpression();
                        if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c38(s1, s5);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseRangeOperator();
            if (s1 !== peg$FAILED) {
                s2 = peg$parseTermType();
                if (s2 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c39(s1, s2);
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        return s0;
    }
    function peg$parseLeftRangeExpression() {
        let s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$parseStartRangeChar();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseLeftRangeType();
                if (s3 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c40(s1, s3);
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseRightRangeExpression() {
        let s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parsews();
        while (s2 !== peg$FAILED) {
            s1.push(s2);
            s2 = peg$parsews();
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$parseRightRangeType();
            if (s2 !== peg$FAILED) {
                s3 = peg$parseEndRangeChar();
                if (s3 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c41(s2, s3);
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseOldGeoTermType() {
        let s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$parseOldGeoPoint();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseOldGeoDistance();
                if (s3 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c42(s1, s3);
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseOldGeoDistance();
            if (s1 !== peg$FAILED) {
                s2 = [];
                s3 = peg$parsews();
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parsews();
                }
                if (s2 !== peg$FAILED) {
                    s3 = peg$parseOldGeoPoint();
                    if (s3 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1 = peg$c43(s1, s3);
                        s0 = s1;
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
            if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = peg$parseOldGeoTopLeft();
                if (s1 !== peg$FAILED) {
                    s2 = [];
                    s3 = peg$parsews();
                    while (s3 !== peg$FAILED) {
                        s2.push(s3);
                        s3 = peg$parsews();
                    }
                    if (s2 !== peg$FAILED) {
                        s3 = peg$parseOldGeoBottomRight();
                        if (s3 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c44(s1, s3);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    s1 = peg$parseOldGeoBottomRight();
                    if (s1 !== peg$FAILED) {
                        s2 = [];
                        s3 = peg$parsews();
                        while (s3 !== peg$FAILED) {
                            s2.push(s3);
                            s3 = peg$parsews();
                        }
                        if (s2 !== peg$FAILED) {
                            s3 = peg$parseOldGeoTopLeft();
                            if (s3 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c45(s1, s3);
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
            }
        }
        return s0;
    }
    function peg$parseLeftRangeType() {
        let s0;
        s0 = peg$parseNegativeInfinityType();
        if (s0 === peg$FAILED) {
            s0 = peg$parseRangeTermType();
        }
        return s0;
    }
    function peg$parseRightRangeType() {
        let s0;
        s0 = peg$parsePostiveInfinityType();
        if (s0 === peg$FAILED) {
            s0 = peg$parseRangeTermType();
        }
        return s0;
    }
    function peg$parseRangeTermType() {
        let s0;
        s0 = peg$parseFloatType();
        if (s0 === peg$FAILED) {
            s0 = peg$parseIntegerType();
            if (s0 === peg$FAILED) {
                s0 = peg$parseVariableType();
                if (s0 === peg$FAILED) {
                    s0 = peg$parseQuotedStringType();
                    if (s0 === peg$FAILED) {
                        s0 = peg$parseRestrictedStringType();
                    }
                }
            }
        }
        return s0;
    }
    function peg$parseTermType() {
        let s0;
        s0 = peg$parseVariableType();
        if (s0 === peg$FAILED) {
            s0 = peg$parseRegexpType();
            if (s0 === peg$FAILED) {
                s0 = peg$parseQuotedStringType();
                if (s0 === peg$FAILED) {
                    s0 = peg$parseParensStringType();
                    if (s0 === peg$FAILED) {
                        s0 = peg$parseWildcardType();
                        if (s0 === peg$FAILED) {
                            s0 = peg$parseBooleanType();
                            if (s0 === peg$FAILED) {
                                s0 = peg$parseFloatType();
                                if (s0 === peg$FAILED) {
                                    s0 = peg$parseIntegerType();
                                    if (s0 === peg$FAILED) {
                                        s0 = peg$parseRestrictedStringType();
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return s0;
    }
    function peg$parseNegativeInfinityType() {
        let s0, s1;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 42) {
            s1 = peg$c46;
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c47);
            }
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c48();
        }
        s0 = s1;
        return s0;
    }
    function peg$parsePostiveInfinityType() {
        let s0, s1;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 42) {
            s1 = peg$c46;
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c47);
            }
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c49();
        }
        s0 = s1;
        return s0;
    }
    function peg$parseVariableType() {
        let s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$parseVariableSign();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parseVariableChar();
            if (s3 !== peg$FAILED) {
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parseVariableChar();
                }
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c50(s2);
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseFloatType() {
        let s0, s1;
        s0 = peg$currPos;
        s1 = peg$parseFloat();
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c51(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseIntegerType() {
        let s0, s1;
        s0 = peg$currPos;
        s1 = peg$parseInteger();
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c52(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseBooleanType() {
        let s0, s1, s2, s3, s4;
        s0 = peg$currPos;
        s1 = peg$parseBoolean();
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            peg$silentFails++;
            s3 = peg$parseEOF();
            if (s3 === peg$FAILED) {
                s3 = [];
                s4 = peg$parsews();
                if (s4 !== peg$FAILED) {
                    while (s4 !== peg$FAILED) {
                        s3.push(s4);
                        s4 = peg$parsews();
                    }
                }
                else {
                    s3 = peg$FAILED;
                }
                if (s3 === peg$FAILED) {
                    s3 = peg$parseParensEnd();
                    if (s3 === peg$FAILED) {
                        if (input.charCodeAt(peg$currPos) === 93) {
                            s3 = peg$c53;
                            peg$currPos++;
                        }
                        else {
                            s3 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c54);
                            }
                        }
                    }
                }
            }
            peg$silentFails--;
            if (s3 !== peg$FAILED) {
                peg$currPos = s2;
                s2 = undefined;
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c55(s1);
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseRegexpType() {
        let s0, s1;
        s0 = peg$currPos;
        s1 = peg$parseRegex();
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c56(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseWildcardType() {
        let s0, s1;
        s0 = peg$currPos;
        s1 = peg$parseWildcard();
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c57(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseQuotedStringType() {
        let s0, s1;
        s0 = peg$currPos;
        s1 = peg$parseQuotedTerm();
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c58(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseUnqoutedStringType() {
        let s0, s1;
        s0 = peg$currPos;
        s1 = peg$parseUnquotedTerm();
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c59(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseRestrictedStringType() {
        let s0, s1;
        s0 = peg$currPos;
        s1 = peg$parseRestrictedString();
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c60(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseFieldName() {
        let s0, s1, s2;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parseFieldChar();
        if (s2 !== peg$FAILED) {
            while (s2 !== peg$FAILED) {
                s1.push(s2);
                s2 = peg$parseFieldChar();
            }
        }
        else {
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c61(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseOldGeoPoint() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseOldGeoPointKeyword();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseFieldSeparator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseQuotedStringType();
                        if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c62(s5);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseOldGeoDistance() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseOldGeoDistanceKeyword();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseFieldSeparator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseOldGeoDistanceType();
                        if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c63(s5);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseOldGeoDistanceType() {
        let s0;
        s0 = peg$parseRestrictedStringType();
        if (s0 === peg$FAILED) {
            s0 = peg$parseQuotedStringType();
        }
        return s0;
    }
    function peg$parseOldGeoTopLeft() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseOldGeoTopLeftKeyword();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseFieldSeparator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseQuotedStringType();
                        if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c64(s5);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseOldGeoBottomRight() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseOldGeoBottomRightKeyword();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parsews();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsews();
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseFieldSeparator();
                if (s3 !== peg$FAILED) {
                    s4 = [];
                    s5 = peg$parsews();
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsews();
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseQuotedStringType();
                        if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c65(s5);
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseUnquotedTerm() {
        let s0, s1, s2;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parseTermChar();
        if (s2 !== peg$FAILED) {
            while (s2 !== peg$FAILED) {
                s1.push(s2);
                s2 = peg$parseTermChar();
            }
        }
        else {
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c66(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseRestrictedString() {
        let s0, s1, s2;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parseRestrictedTermChar();
        if (s2 !== peg$FAILED) {
            while (s2 !== peg$FAILED) {
                s1.push(s2);
                s2 = peg$parseRestrictedTermChar();
            }
        }
        else {
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c66(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseWildcard() {
        let s0, s1, s2;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parseWildcardCharSet();
        if (s2 !== peg$FAILED) {
            while (s2 !== peg$FAILED) {
                s1.push(s2);
                s2 = peg$parseWildcardCharSet();
            }
        }
        else {
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c66(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseRegex() {
        let s0, s1, s2, s3;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 47) {
            s1 = peg$c67;
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c68);
            }
        }
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parseRegexStringChar();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parseRegexStringChar();
            }
            if (s2 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 47) {
                    s3 = peg$c67;
                    peg$currPos++;
                }
                else {
                    s3 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c68);
                    }
                }
                if (s3 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c69(s2);
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseInteger() {
        let s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseZero();
        if (s2 === peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parseOneToNine();
            if (s3 !== peg$FAILED) {
                s4 = [];
                s5 = peg$parseDigit();
                while (s5 !== peg$FAILED) {
                    s4.push(s5);
                    s5 = peg$parseDigit();
                }
                if (s4 !== peg$FAILED) {
                    s3 = [s3, s4];
                    s2 = s3;
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
        }
        if (s2 !== peg$FAILED) {
            s1 = input.substring(s1, peg$currPos);
        }
        else {
            s1 = s2;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            peg$silentFails++;
            s3 = peg$parseNumReservedChar();
            peg$silentFails--;
            if (s3 !== peg$FAILED) {
                peg$currPos = s2;
                s2 = undefined;
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c70(s1);
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseFloat() {
        let s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$currPos;
        s3 = [];
        s4 = peg$parseDigit();
        while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$parseDigit();
        }
        if (s3 !== peg$FAILED) {
            s4 = peg$parseDot();
            if (s4 !== peg$FAILED) {
                s5 = [];
                s6 = peg$parseDigit();
                if (s6 !== peg$FAILED) {
                    while (s6 !== peg$FAILED) {
                        s5.push(s6);
                        s6 = peg$parseDigit();
                    }
                }
                else {
                    s5 = peg$FAILED;
                }
                if (s5 !== peg$FAILED) {
                    s3 = [s3, s4, s5];
                    s2 = s3;
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s2;
            s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
            s1 = input.substring(s1, peg$currPos);
        }
        else {
            s1 = s2;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            peg$silentFails++;
            s3 = peg$parseNumReservedChar();
            peg$silentFails--;
            if (s3 !== peg$FAILED) {
                peg$currPos = s2;
                s2 = undefined;
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c71(s1);
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseExistsKeyword() {
        let s0;
        if (input.substr(peg$currPos, 8) === peg$c72) {
            s0 = peg$c72;
            peg$currPos += 8;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c73);
            }
        }
        return s0;
    }
    function peg$parseOldGeoPointKeyword() {
        let s0;
        if (input.substr(peg$currPos, 11) === peg$c74) {
            s0 = peg$c74;
            peg$currPos += 11;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c75);
            }
        }
        return s0;
    }
    function peg$parseOldGeoDistanceKeyword() {
        let s0;
        if (input.substr(peg$currPos, 14) === peg$c76) {
            s0 = peg$c76;
            peg$currPos += 14;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c77);
            }
        }
        return s0;
    }
    function peg$parseOldGeoTopLeftKeyword() {
        let s0;
        if (input.substr(peg$currPos, 18) === peg$c78) {
            s0 = peg$c78;
            peg$currPos += 18;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c79);
            }
        }
        return s0;
    }
    function peg$parseOldGeoBottomRightKeyword() {
        let s0;
        if (input.substr(peg$currPos, 22) === peg$c80) {
            s0 = peg$c80;
            peg$currPos += 22;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c81);
            }
        }
        return s0;
    }
    function peg$parseBoolean() {
        let s0, s1;
        s0 = peg$currPos;
        if (input.substr(peg$currPos, 4) === peg$c82) {
            s1 = peg$c82;
            peg$currPos += 4;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c83);
            }
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c84();
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.substr(peg$currPos, 5) === peg$c85) {
                s1 = peg$c85;
                peg$currPos += 5;
            }
            else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c86);
                }
            }
            if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c87();
            }
            s0 = s1;
        }
        return s0;
    }
    function peg$parseRangeOperator() {
        let s0, s1;
        s0 = peg$currPos;
        if (input.substr(peg$currPos, 2) === peg$c88) {
            s1 = peg$c88;
            peg$currPos += 2;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c89);
            }
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c90();
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 62) {
                s1 = peg$c91;
                peg$currPos++;
            }
            else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c92);
                }
            }
            if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c93();
            }
            s0 = s1;
            if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                if (input.substr(peg$currPos, 2) === peg$c94) {
                    s1 = peg$c94;
                    peg$currPos += 2;
                }
                else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c95);
                    }
                }
                if (s1 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c96();
                }
                s0 = s1;
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    if (input.charCodeAt(peg$currPos) === 60) {
                        s1 = peg$c97;
                        peg$currPos++;
                    }
                    else {
                        s1 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c98);
                        }
                    }
                    if (s1 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1 = peg$c99();
                    }
                    s0 = s1;
                }
            }
        }
        return s0;
    }
    function peg$parseStartRangeChar() {
        let s0, s1;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 91) {
            s1 = peg$c100;
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c101);
            }
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c90();
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 123) {
                s1 = peg$c102;
                peg$currPos++;
            }
            else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c103);
                }
            }
            if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c93();
            }
            s0 = s1;
        }
        return s0;
    }
    function peg$parseEndRangeChar() {
        let s0, s1;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 93) {
            s1 = peg$c53;
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c54);
            }
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c96();
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 125) {
                s1 = peg$c104;
                peg$currPos++;
            }
            else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c105);
                }
            }
            if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c99();
            }
            s0 = s1;
        }
        return s0;
    }
    function peg$parseRangeJoinOperator() {
        let s0;
        if (input.substr(peg$currPos, 2) === peg$c106) {
            s0 = peg$c106;
            peg$currPos += 2;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c107);
            }
        }
        return s0;
    }
    function peg$parseParensStart() {
        let s0;
        if (input.charCodeAt(peg$currPos) === 40) {
            s0 = peg$c108;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c109);
            }
        }
        return s0;
    }
    function peg$parseParensEnd() {
        let s0;
        if (input.charCodeAt(peg$currPos) === 41) {
            s0 = peg$c110;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c111);
            }
        }
        return s0;
    }
    function peg$parseListStart() {
        let s0;
        if (input.charCodeAt(peg$currPos) === 91) {
            s0 = peg$c100;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c101);
            }
        }
        return s0;
    }
    function peg$parseListEnd() {
        let s0;
        if (input.charCodeAt(peg$currPos) === 93) {
            s0 = peg$c53;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c54);
            }
        }
        return s0;
    }
    function peg$parseComma() {
        let s0;
        if (input.charCodeAt(peg$currPos) === 44) {
            s0 = peg$c112;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c113);
            }
        }
        return s0;
    }
    function peg$parseWildcardCharSet() {
        let s0, s1, s2, s3, s4, s5;
        peg$silentFails++;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = [];
        if (peg$c115.test(input.charAt(peg$currPos))) {
            s3 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c116);
            }
        }
        while (s3 !== peg$FAILED) {
            s2.push(s3);
            if (peg$c115.test(input.charAt(peg$currPos))) {
                s3 = input.charAt(peg$currPos);
                peg$currPos++;
            }
            else {
                s3 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c116);
                }
            }
        }
        if (s2 !== peg$FAILED) {
            s3 = [];
            if (input.charCodeAt(peg$currPos) === 63) {
                s4 = peg$c117;
                peg$currPos++;
            }
            else {
                s4 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c118);
                }
            }
            if (s4 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 42) {
                    s4 = peg$c46;
                    peg$currPos++;
                }
                else {
                    s4 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c47);
                    }
                }
            }
            if (s4 !== peg$FAILED) {
                while (s4 !== peg$FAILED) {
                    s3.push(s4);
                    if (input.charCodeAt(peg$currPos) === 63) {
                        s4 = peg$c117;
                        peg$currPos++;
                    }
                    else {
                        s4 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c118);
                        }
                    }
                    if (s4 === peg$FAILED) {
                        if (input.charCodeAt(peg$currPos) === 42) {
                            s4 = peg$c46;
                            peg$currPos++;
                        }
                        else {
                            s4 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c47);
                            }
                        }
                    }
                }
            }
            else {
                s3 = peg$FAILED;
            }
            if (s3 !== peg$FAILED) {
                s4 = [];
                if (peg$c119.test(input.charAt(peg$currPos))) {
                    s5 = input.charAt(peg$currPos);
                    peg$currPos++;
                }
                else {
                    s5 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c120);
                    }
                }
                while (s5 !== peg$FAILED) {
                    s4.push(s5);
                    if (peg$c119.test(input.charAt(peg$currPos))) {
                        s5 = input.charAt(peg$currPos);
                        peg$currPos++;
                    }
                    else {
                        s5 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c120);
                        }
                    }
                }
                if (s4 !== peg$FAILED) {
                    s2 = [s2, s3, s4];
                    s1 = s2;
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            s0 = input.substring(s0, peg$currPos);
        }
        else {
            s0 = s1;
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c114);
            }
        }
        return s0;
    }
    function peg$parseFieldChar() {
        let s0, s1;
        peg$silentFails++;
        if (peg$c122.test(input.charAt(peg$currPos))) {
            s0 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c123);
            }
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c121);
            }
        }
        return s0;
    }
    function peg$parseVariableChar() {
        let s0;
        if (peg$c124.test(input.charAt(peg$currPos))) {
            s0 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c125);
            }
        }
        return s0;
    }
    function peg$parseFieldSeparator() {
        let s0, s1;
        peg$silentFails++;
        if (input.charCodeAt(peg$currPos) === 58) {
            s0 = peg$c127;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c128);
            }
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c126);
            }
        }
        return s0;
    }
    function peg$parseTermChar() {
        let s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parseEscape();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseReservedChar();
            if (s2 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c129(s2);
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$parseDot();
            if (s0 === peg$FAILED) {
                s0 = peg$parseCharWithWS();
            }
        }
        return s0;
    }
    function peg$parseDot() {
        let s0, s1;
        peg$silentFails++;
        if (input.charCodeAt(peg$currPos) === 46) {
            s0 = peg$c130;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c131);
            }
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c126);
            }
        }
        return s0;
    }
    function peg$parseCharWithWS() {
        let s0, s1;
        peg$silentFails++;
        if (peg$c133.test(input.charAt(peg$currPos))) {
            s0 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c134);
            }
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c132);
            }
        }
        return s0;
    }
    function peg$parseRestrictedTermChar() {
        let s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parseEscape();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseReservedChar();
            if (s2 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c129(s2);
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$parseDot();
            if (s0 === peg$FAILED) {
                s0 = peg$parseCharWithoutWS();
            }
        }
        return s0;
    }
    function peg$parseCharWithoutWS() {
        let s0, s1;
        peg$silentFails++;
        if (peg$c135.test(input.charAt(peg$currPos))) {
            s0 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c136);
            }
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c132);
            }
        }
        return s0;
    }
    function peg$parseQuotedTerm() {
        let s0, s1, s2, s3;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 34) {
            s1 = peg$c137;
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c138);
            }
        }
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parseDoubleStringCharacter();
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parseDoubleStringCharacter();
            }
            if (s2 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 34) {
                    s3 = peg$c137;
                    peg$currPos++;
                }
                else {
                    s3 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c138);
                    }
                }
                if (s3 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c69(s2);
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 39) {
                s1 = peg$c139;
                peg$currPos++;
            }
            else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c140);
                }
            }
            if (s1 !== peg$FAILED) {
                s2 = [];
                s3 = peg$parseSingleStringCharacter();
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parseSingleStringCharacter();
                }
                if (s2 !== peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 39) {
                        s3 = peg$c139;
                        peg$currPos++;
                    }
                    else {
                        s3 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c140);
                        }
                    }
                    if (s3 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1 = peg$c69(s2);
                        s0 = s1;
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        return s0;
    }
    function peg$parseDoubleStringCharacter() {
        let s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$currPos;
        peg$silentFails++;
        if (input.charCodeAt(peg$currPos) === 34) {
            s2 = peg$c137;
            peg$currPos++;
        }
        else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c138);
            }
        }
        if (s2 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 92) {
                s2 = peg$c141;
                peg$currPos++;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c142);
                }
            }
        }
        peg$silentFails--;
        if (s2 === peg$FAILED) {
            s1 = undefined;
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            if (input.length > peg$currPos) {
                s2 = input.charAt(peg$currPos);
                peg$currPos++;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c143);
                }
            }
            if (s2 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c144(s2);
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 92) {
                s1 = peg$c141;
                peg$currPos++;
            }
            else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c142);
                }
            }
            if (s1 !== peg$FAILED) {
                s2 = peg$parseEscapeSequence();
                if (s2 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c145(s2);
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        return s0;
    }
    function peg$parseSingleStringCharacter() {
        let s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$currPos;
        peg$silentFails++;
        if (input.charCodeAt(peg$currPos) === 39) {
            s2 = peg$c139;
            peg$currPos++;
        }
        else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c140);
            }
        }
        if (s2 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 92) {
                s2 = peg$c141;
                peg$currPos++;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c142);
                }
            }
        }
        peg$silentFails--;
        if (s2 === peg$FAILED) {
            s1 = undefined;
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            if (input.length > peg$currPos) {
                s2 = input.charAt(peg$currPos);
                peg$currPos++;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c143);
                }
            }
            if (s2 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c144(s2);
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 92) {
                s1 = peg$c141;
                peg$currPos++;
            }
            else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c142);
                }
            }
            if (s1 !== peg$FAILED) {
                s2 = peg$parseEscapeSequence();
                if (s2 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c145(s2);
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        return s0;
    }
    function peg$parseEscapeSequence() {
        let s0, s1;
        if (input.charCodeAt(peg$currPos) === 39) {
            s0 = peg$c139;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c140);
            }
        }
        if (s0 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 34) {
                s0 = peg$c137;
                peg$currPos++;
            }
            else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c138);
                }
            }
            if (s0 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 92) {
                    s0 = peg$c141;
                    peg$currPos++;
                }
                else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c142);
                    }
                }
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    if (input.charCodeAt(peg$currPos) === 98) {
                        s1 = peg$c146;
                        peg$currPos++;
                    }
                    else {
                        s1 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c147);
                        }
                    }
                    if (s1 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1 = peg$c148();
                    }
                    s0 = s1;
                    if (s0 === peg$FAILED) {
                        s0 = peg$currPos;
                        if (input.charCodeAt(peg$currPos) === 102) {
                            s1 = peg$c149;
                            peg$currPos++;
                        }
                        else {
                            s1 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c150);
                            }
                        }
                        if (s1 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c151();
                        }
                        s0 = s1;
                        if (s0 === peg$FAILED) {
                            s0 = peg$currPos;
                            if (input.charCodeAt(peg$currPos) === 110) {
                                s1 = peg$c152;
                                peg$currPos++;
                            }
                            else {
                                s1 = peg$FAILED;
                                if (peg$silentFails === 0) {
                                    peg$fail(peg$c153);
                                }
                            }
                            if (s1 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c154();
                            }
                            s0 = s1;
                            if (s0 === peg$FAILED) {
                                s0 = peg$currPos;
                                if (input.charCodeAt(peg$currPos) === 114) {
                                    s1 = peg$c155;
                                    peg$currPos++;
                                }
                                else {
                                    s1 = peg$FAILED;
                                    if (peg$silentFails === 0) {
                                        peg$fail(peg$c156);
                                    }
                                }
                                if (s1 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1 = peg$c157();
                                }
                                s0 = s1;
                                if (s0 === peg$FAILED) {
                                    s0 = peg$currPos;
                                    if (input.charCodeAt(peg$currPos) === 116) {
                                        s1 = peg$c158;
                                        peg$currPos++;
                                    }
                                    else {
                                        s1 = peg$FAILED;
                                        if (peg$silentFails === 0) {
                                            peg$fail(peg$c159);
                                        }
                                    }
                                    if (s1 !== peg$FAILED) {
                                        peg$savedPos = s0;
                                        s1 = peg$c160();
                                    }
                                    s0 = s1;
                                    if (s0 === peg$FAILED) {
                                        s0 = peg$currPos;
                                        if (input.charCodeAt(peg$currPos) === 118) {
                                            s1 = peg$c161;
                                            peg$currPos++;
                                        }
                                        else {
                                            s1 = peg$FAILED;
                                            if (peg$silentFails === 0) {
                                                peg$fail(peg$c162);
                                            }
                                        }
                                        if (s1 !== peg$FAILED) {
                                            peg$savedPos = s0;
                                            s1 = peg$c163();
                                        }
                                        s0 = s1;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return s0;
    }
    function peg$parseRegexStringChar() {
        let s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$currPos;
        peg$silentFails++;
        if (input.charCodeAt(peg$currPos) === 47) {
            s2 = peg$c67;
            peg$currPos++;
        }
        else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c68);
            }
        }
        if (s2 === peg$FAILED) {
            s2 = peg$parseEscape();
        }
        peg$silentFails--;
        if (s2 === peg$FAILED) {
            s1 = undefined;
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            if (input.length > peg$currPos) {
                s2 = input.charAt(peg$currPos);
                peg$currPos++;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c143);
                }
            }
            if (s2 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c144(s2);
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseEscape();
            if (s1 !== peg$FAILED) {
                s2 = peg$parseReservedChar();
                if (s2 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c129(s2);
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        return s0;
    }
    function peg$parseAndConjunctionOperator() {
        let s0;
        if (input.substr(peg$currPos, 3) === peg$c164) {
            s0 = peg$c164;
            peg$currPos += 3;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c165);
            }
        }
        if (s0 === peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c166) {
                s0 = peg$c166;
                peg$currPos += 2;
            }
            else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c167);
                }
            }
        }
        return s0;
    }
    function peg$parseOrConjunctionOperator() {
        let s0;
        if (input.substr(peg$currPos, 2) === peg$c168) {
            s0 = peg$c168;
            peg$currPos += 2;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c169);
            }
        }
        if (s0 === peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c170) {
                s0 = peg$c170;
                peg$currPos += 2;
            }
            else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c171);
                }
            }
        }
        return s0;
    }
    function peg$parseConjunctionOperator() {
        let s0;
        s0 = peg$parseAndConjunctionOperator();
        if (s0 === peg$FAILED) {
            s0 = peg$parseOrConjunctionOperator();
        }
        return s0;
    }
    function peg$parseNotOperator() {
        let s0;
        if (input.substr(peg$currPos, 3) === peg$c10) {
            s0 = peg$c10;
            peg$currPos += 3;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c11);
            }
        }
        if (s0 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 33) {
                s0 = peg$c17;
                peg$currPos++;
            }
            else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c18);
                }
            }
        }
        return s0;
    }
    function peg$parseZero() {
        let s0;
        if (input.charCodeAt(peg$currPos) === 48) {
            s0 = peg$c172;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c173);
            }
        }
        return s0;
    }
    function peg$parseEscape() {
        let s0, s1;
        peg$silentFails++;
        if (input.charCodeAt(peg$currPos) === 92) {
            s0 = peg$c141;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c142);
            }
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c126);
            }
        }
        return s0;
    }
    function peg$parseOneToNine() {
        let s0, s1;
        peg$silentFails++;
        if (peg$c175.test(input.charAt(peg$currPos))) {
            s0 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c176);
            }
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c174);
            }
        }
        return s0;
    }
    function peg$parseDigit() {
        let s0, s1;
        peg$silentFails++;
        if (peg$c178.test(input.charAt(peg$currPos))) {
            s0 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c179);
            }
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c177);
            }
        }
        return s0;
    }
    function peg$parseVariableSign() {
        let s0;
        if (input.charCodeAt(peg$currPos) === 36) {
            s0 = peg$c180;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c181);
            }
        }
        return s0;
    }
    function peg$parseNumReservedChar() {
        let s0;
        if (input.charCodeAt(peg$currPos) === 32) {
            s0 = peg$c182;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c183);
            }
        }
        if (s0 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 93) {
                s0 = peg$c53;
                peg$currPos++;
            }
            else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c54);
                }
            }
            if (s0 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 125) {
                    s0 = peg$c104;
                    peg$currPos++;
                }
                else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c105);
                    }
                }
                if (s0 === peg$FAILED) {
                    s0 = peg$parseParensEnd();
                    if (s0 === peg$FAILED) {
                        s0 = peg$parseEOF();
                    }
                }
            }
        }
        return s0;
    }
    function peg$parseReservedChar() {
        let s0;
        if (input.charCodeAt(peg$currPos) === 43) {
            s0 = peg$c184;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c185);
            }
        }
        if (s0 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 45) {
                s0 = peg$c186;
                peg$currPos++;
            }
            else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c187);
                }
            }
            if (s0 === peg$FAILED) {
                s0 = peg$parseParensStart();
                if (s0 === peg$FAILED) {
                    s0 = peg$parseParensEnd();
                    if (s0 === peg$FAILED) {
                        if (input.charCodeAt(peg$currPos) === 123) {
                            s0 = peg$c102;
                            peg$currPos++;
                        }
                        else {
                            s0 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c103);
                            }
                        }
                        if (s0 === peg$FAILED) {
                            if (input.charCodeAt(peg$currPos) === 125) {
                                s0 = peg$c104;
                                peg$currPos++;
                            }
                            else {
                                s0 = peg$FAILED;
                                if (peg$silentFails === 0) {
                                    peg$fail(peg$c105);
                                }
                            }
                            if (s0 === peg$FAILED) {
                                if (input.charCodeAt(peg$currPos) === 91) {
                                    s0 = peg$c100;
                                    peg$currPos++;
                                }
                                else {
                                    s0 = peg$FAILED;
                                    if (peg$silentFails === 0) {
                                        peg$fail(peg$c101);
                                    }
                                }
                                if (s0 === peg$FAILED) {
                                    if (input.charCodeAt(peg$currPos) === 93) {
                                        s0 = peg$c53;
                                        peg$currPos++;
                                    }
                                    else {
                                        s0 = peg$FAILED;
                                        if (peg$silentFails === 0) {
                                            peg$fail(peg$c54);
                                        }
                                    }
                                    if (s0 === peg$FAILED) {
                                        if (input.charCodeAt(peg$currPos) === 94) {
                                            s0 = peg$c188;
                                            peg$currPos++;
                                        }
                                        else {
                                            s0 = peg$FAILED;
                                            if (peg$silentFails === 0) {
                                                peg$fail(peg$c189);
                                            }
                                        }
                                        if (s0 === peg$FAILED) {
                                            if (input.charCodeAt(peg$currPos) === 34) {
                                                s0 = peg$c137;
                                                peg$currPos++;
                                            }
                                            else {
                                                s0 = peg$FAILED;
                                                if (peg$silentFails === 0) {
                                                    peg$fail(peg$c138);
                                                }
                                            }
                                            if (s0 === peg$FAILED) {
                                                if (input.charCodeAt(peg$currPos) === 39) {
                                                    s0 = peg$c139;
                                                    peg$currPos++;
                                                }
                                                else {
                                                    s0 = peg$FAILED;
                                                    if (peg$silentFails === 0) {
                                                        peg$fail(peg$c140);
                                                    }
                                                }
                                                if (s0 === peg$FAILED) {
                                                    if (input.charCodeAt(peg$currPos) === 63) {
                                                        s0 = peg$c117;
                                                        peg$currPos++;
                                                    }
                                                    else {
                                                        s0 = peg$FAILED;
                                                        if (peg$silentFails === 0) {
                                                            peg$fail(peg$c118);
                                                        }
                                                    }
                                                    if (s0 === peg$FAILED) {
                                                        s0 = peg$parseFieldChar();
                                                        if (s0 === peg$FAILED) {
                                                            s0 = peg$parseEscape();
                                                            if (s0 === peg$FAILED) {
                                                                if (input.charCodeAt(peg$currPos) === 38) {
                                                                    s0 = peg$c190;
                                                                    peg$currPos++;
                                                                }
                                                                else {
                                                                    s0 = peg$FAILED;
                                                                    if (peg$silentFails === 0) {
                                                                        peg$fail(peg$c191);
                                                                    }
                                                                }
                                                                if (s0 === peg$FAILED) {
                                                                    if (input.charCodeAt(peg$currPos) === 124) {
                                                                        s0 = peg$c192;
                                                                        peg$currPos++;
                                                                    }
                                                                    else {
                                                                        s0 = peg$FAILED;
                                                                        if (peg$silentFails === 0) {
                                                                            peg$fail(peg$c193);
                                                                        }
                                                                    }
                                                                    if (s0 === peg$FAILED) {
                                                                        if (input.charCodeAt(peg$currPos) === 47) {
                                                                            s0 = peg$c67;
                                                                            peg$currPos++;
                                                                        }
                                                                        else {
                                                                            s0 = peg$FAILED;
                                                                            if (peg$silentFails === 0) {
                                                                                peg$fail(peg$c68);
                                                                            }
                                                                        }
                                                                        if (s0 === peg$FAILED) {
                                                                            if (input.charCodeAt(peg$currPos) === 126) {
                                                                                s0 = peg$c194;
                                                                                peg$currPos++;
                                                                            }
                                                                            else {
                                                                                s0 = peg$FAILED;
                                                                                if (peg$silentFails === 0) {
                                                                                    peg$fail(peg$c195);
                                                                                }
                                                                            }
                                                                            if (s0 === peg$FAILED) {
                                                                                if (input.charCodeAt(peg$currPos) === 42) {
                                                                                    s0 = peg$c46;
                                                                                    peg$currPos++;
                                                                                }
                                                                                else {
                                                                                    s0 = peg$FAILED;
                                                                                    if (peg$silentFails === 0) {
                                                                                        peg$fail(peg$c47);
                                                                                    }
                                                                                }
                                                                                if (s0 === peg$FAILED) {
                                                                                    if (input.charCodeAt(peg$currPos) === 32) {
                                                                                        s0 = peg$c182;
                                                                                        peg$currPos++;
                                                                                    }
                                                                                    else {
                                                                                        s0 = peg$FAILED;
                                                                                        if (peg$silentFails === 0) {
                                                                                            peg$fail(peg$c183);
                                                                                        }
                                                                                    }
                                                                                    if (s0 === peg$FAILED) {
                                                                                        s0 = peg$parseConjunctionOperator();
                                                                                        if (s0 === peg$FAILED) {
                                                                                            s0 = peg$parseNotOperator();
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return s0;
    }
    function peg$parseEOF() {
        let s0, s1;
        s0 = peg$currPos;
        peg$silentFails++;
        if (input.length > peg$currPos) {
            s1 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c143);
            }
        }
        peg$silentFails--;
        if (s1 === peg$FAILED) {
            s0 = undefined;
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsews() {
        let s0, s1;
        peg$silentFails++;
        if (input.charCodeAt(peg$currPos) === 9) {
            s0 = peg$c197;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c198);
            }
        }
        if (s0 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 11) {
                s0 = peg$c199;
                peg$currPos++;
            }
            else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c200);
                }
            }
            if (s0 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 12) {
                    s0 = peg$c201;
                    peg$currPos++;
                }
                else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c202);
                    }
                }
                if (s0 === peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 32) {
                        s0 = peg$c182;
                        peg$currPos++;
                    }
                    else {
                        s0 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c183);
                        }
                    }
                }
            }
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c196);
            }
        }
        return s0;
    }
    const { parseGeoPoint, parseGeoDistance, coerceTermType, parseInferredTermType, isInferredTermType, propagateDefaultField, parseFunction, getVariable, makeFlow, validateRestrictedVariable, } = context_1.default(options.contextArg);
    peg$result = peg$startRuleFunction();
    if (peg$result !== peg$FAILED && peg$currPos === input.length) {
        return peg$result;
    }
    else {
        if (peg$result !== peg$FAILED && peg$currPos < input.length) {
            peg$fail(peg$endExpectation());
        }
        throw peg$buildStructuredError(peg$maxFailExpected, peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null, peg$maxFailPos < input.length
            ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1)
            : peg$computeLocation(peg$maxFailPos, peg$maxFailPos));
    }
}
exports.parse = peg$parse;
//# sourceMappingURL=peg-engine.js.map