"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const query_access_1 = require("./query-access");
const _cache = new WeakMap();
class CachedQueryAccess {
    constructor() {
        _cache.set(this, {});
    }
    make(config, options) {
        return new query_access_1.QueryAccess(config, options);
    }
    reset() {
        this.resetInstances();
        _cache.delete(this);
        _cache.set(this, {});
    }
    resetInstances() {
        const cached = _cache.get(this);
        Object.values(cached)
            .forEach((instance) => instance.clearCache());
    }
}
exports.CachedQueryAccess = CachedQueryAccess;
//# sourceMappingURL=cached-query-access.js.map