"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@terascope/utils");
const translator_1 = require("./translator");
const _cache = new WeakMap();
class CachedTranslator {
    constructor() {
        _cache.set(this, {});
    }
    make(input, options) {
        const query = utils_1.isString(input) ? input : input.query;
        return new translator_1.Translator(query, options);
    }
    reset() {
        _cache.delete(this);
        _cache.set(this, {});
    }
}
exports.CachedTranslator = CachedTranslator;
//# sourceMappingURL=cached-translator.js.map