import { AnyObject } from '@terascope/utils';
import { Range } from './parser/interfaces';
import { GeoDistanceObj, GeoPointInput, GeoPoint, GeoDistanceUnit, CoordinateTuple, JoinQueryResult, CreateJoinQueryOptions } from './interfaces';
export declare function isInfiniteValue(input?: number | string): boolean;
export declare function isInfiniteMin(min?: number | string): boolean;
export declare function isInfiniteMax(max?: number | string): boolean;
export interface ParsedRange {
    'gte'?: number | string;
    'gt'?: number | string;
    'lte'?: number | string;
    'lt'?: number | string;
}
export declare function parseRange(node: Range, excludeInfinite?: boolean): ParsedRange;
export declare function buildRangeQueryString(node: Range): string | undefined;
export declare const GEO_DISTANCE_UNITS: {
    readonly [key: string]: GeoDistanceUnit;
};
export declare function parseGeoDistance(str: string): GeoDistanceObj;
export declare function parseGeoDistanceUnit(input: string): GeoDistanceUnit;
/** @returns {[lat, lon]} */
export declare function getLonAndLat(input: any, throwInvalid?: boolean): [number, number] | null;
export declare function parseGeoPoint(point: GeoPointInput): GeoPoint;
export declare function parseGeoPoint(point: GeoPointInput, throwInvalid: true): GeoPoint;
export declare function parseGeoPoint(point: GeoPointInput, throwInvalid: false): GeoPoint | null;
export declare function coordinateToXlucene(cord: CoordinateTuple): string;
export declare function createJoinQuery(input: AnyObject, options?: CreateJoinQueryOptions): JoinQueryResult;
export declare class VariableState {
    private variables;
    constructor(variables?: AnyObject);
    private _makeKey;
    createVariable(field: string, value: any): string;
    /**
     * Shallow clones and sorts the keys
    */
    getVariables(): AnyObject;
}
//# sourceMappingURL=utils.d.ts.map